
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>深入浅出妙用Javascript中apply、call、bind / iVAN</title>

    <meta name="description" content="深入浅出妙用Javascript中apply、call、bind 这篇文章实在是很难下笔,因为网上相关文章不胜枚举. 巧合的是前些天看到阮老师的一篇文章的一句话: &quot;对我来说,博客首先是一种知识管理工具,其次才是传播工具.我的技术文章,主要用来整理我还不懂的知识.我只写那些我还没有完全掌握的东西,那些我精通的东西,往往没有动力写.炫耀从来不是我的动机,好奇才是.&quot; 对于这句话,不能赞同更多,也让我下决心好好写这篇,网上文章虽多,大多复制粘贴,且晦涩难懂,我希望能够通过这篇文章,能够清晰的提升对apply.call.bind的认识,并且列出一 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">深入浅出妙用Javascript中apply、call、bind</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><a href="http://s2.51cto.com/wyfs02/M00/08/23/wKiom1nc17KQNzAeAAA3HzeL1kg754.jpg-wh_651x-s_684485027.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczIuNTFjdG8uY29tL3d5ZnMwMi9NMDAvMDgvMjMvd0tpb20xbmMxN0tRTnpBZUFBQTNIemVMMWtnNzU0LmpwZy13aF82NTF4LXNfNjg0NDg1MDI3LmpwZw==.jpg"></a></p>
<p>这篇文章实在是很难下笔，因为网上相关文章不胜枚举。</p>
<p>巧合的是前些天看到阮老师的一篇文章的一句话：</p>
<p>“对我来说，博客首先是一种知识管理工具，其次才是传播工具。我的技术文章，主要用来整理我还不懂的知识。我只写那些我还没有完全掌握的东西，那些我精通的东西，往往没有动力写。炫耀从来不是我的动机，好奇才是。"</p>
<p>对于这句话，不能赞同更多，也让我下决心好好写这篇，网上文章虽多，大多复制粘贴，且晦涩难懂，我希望能够通过这篇文章，能够清晰的提升对apply、call、bind的认识，并且列出一些它们的妙用加深记忆。</p>
<p><strong>apply、call</strong></p>
<p>在 javascript 中，call 和 apply 都是为了改变某个函数运行时的上下文(context)而存在的，换句话说，就是为了改变函数体内部  this 的指向。</p>
<p>JavaScript 的一大特点是，函数存在「定义时上下文」和「运行时上下文」以及「上下文是可以改变的」这样的概念。</p>
<p>先来一个栗子：</p>
<pre>
</pre>
<ol>
<li>function fruits() {} </li>
<li> </li>
<li>fruits.prototype = { </li>
<li>color: "red", </li>
<li>say: function() { </li>
<li>console.log("My color is " + this.color); </li>
<li>} </li>
<li>} </li>
<li> </li>
<li>var apple = new fruits; </li>
<li>apple.say(); //My color is red  </li>
</ol>
<p>但是如果我们有一个对象banana= {color : "yellow"} ,我们不想对它重新定义 say 方法，那么我们可以通过 call 或  apply 用 apple 的 say 方法：</p>
<pre>
</pre>
<ol>
<li>banana = { </li>
<li>color: "yellow" </li>
<li>} </li>
<li>apple.say.call(banana); //My color is yellow </li>
<li>apple.say.apply(banana); //My color is yellow  </li>
</ol>
<p>所以，可以看出 call 和 apply 是为了动态改变 this 而出现的，当一个 object<br />
没有某个方法(本栗子中banana没有say方法)，但是其他的有(本栗子中apple有say方法)，我们可以借助call或apply用其它对象的方法来操作。</p>
<p><strong>apply、call 的区别</strong></p>
<p>对于 apply、call 二者而言，作用完全一样，只是接受参数的方式不太一样。例如，有一个函数定义如下：</p>
<pre>
</pre>
<ol>
<li>var func = function(arg1, arg2) { </li>
<li> </li>
<li>};  </li>
</ol>
<p>就可以通过如下方式来调用：</p>
<pre>
</pre>
<ol>
<li>func.call(this, arg1, arg2); </li>
<li> </li>
<li>func.apply(this, [arg1, arg2]) </li>
</ol>
<p>其中 this 是你想指定的上下文，他可以是任何一个 JavaScript 对象(JavaScript 中一切皆对象)，call  需要把参数按顺序传递进去，而 apply 则是把参数放在数组里。</p>
<p>JavaScript 中，某个函数的参数数量是不固定的，因此要说适用条件的话，当你的参数是明确知道数量时用 call 。</p>
<p>而不确定的时候用 apply，然后把参数 push 进数组传递进去。当参数数量不确定时，函数内部也可以通过 arguments  这个数组来遍历所有的参数。</p>
<p>为了巩固加深记忆，下面列举一些常用用法：</p>
<p><strong>1、数组之间追加</strong></p>
<pre>
</pre>
<ol>
<li>var array1 = [12 , "foo" , {name "Joe"} , -2458]; </li>
<li> </li>
<li>var array2 = ["Doe" , 555 , 100]; </li>
<li> </li>
<li>Array.prototype.push.apply(array1, array2); </li>
<li> </li>
<li>/* array1 值为 [12 , "foo" , {name "Joe"} , -2458 , "Doe" , 555 , 100] */  </li>
</ol>
<p><strong>2、获取数组中的最大值和最小值</strong></p>
<pre>
</pre>
<ol>
<li>var numbers = [5, 458 , 120 , -215 ]; </li>
<li> </li>
<li>var maxInNumbers = Math.max.apply(Math, numbers), //458 </li>
<li> </li>
<li>maxInNumbers = Math.max.call(Math,5, 458 , 120 , -215); //458  </li>
</ol>
<p>number 本身没有 max 方法，但是 Math 有，我们就可以借助 call 或者 apply 使用其方法。</p>
<p><strong>3、验证是否是数组(前提是toString()方法没有被重写过)</strong></p>
<pre>
</pre>
<ol>
<li>functionisArray(obj){ </li>
<li> </li>
<li>    returnObject.prototype.toString.call(obj) === '[object Array]' ;  </li>
<li>}  </li>
</ol>
<p><strong>4、类(伪)数组使用数组方法</strong></p>
<pre>
</pre>
<ol>
<li>var domNodes = Array.prototype.slice.call(document.getElementsByTagName("*")); </li>
</ol>
<p>Javascript中存在一种名为伪数组的对象结构。比较特别的是 arguments 对象，还有像调用<br />
getElementsByTagName ,  document.childNodes<br />
之类的，它们返回NodeList对象都属于伪数组。不能应用 Array下的 push , pop 等方法。</p>
<p>但是我们能通过 Array.prototype.slice.call 转换为真正的数组的带有 length 属性的对象，这样 domNodes 就可以应用  Array 下的所有方法了。</p>
<p><strong>深入理解运用apply、call</strong></p>
<p>下面就借用一道面试题，来更深入的去理解下 apply 和 call 。</p>
<p>定义一个 log 方法，让它可以代理 console.log 方法，常见的解决方法是：</p>
<pre>
</pre>
<ol>
<li>function log(msg)　{ </li>
<li>    console.log(msg); </li>
<li>} </li>
<li>log(1); //1 </li>
<li>log(1,2); //1  </li>
</ol>
<p>上面方法可以解决最基本的需求，但是当传入参数的个数是不确定的时候，上面的方法就失效了，这个时候就可以考虑使用 apply 或者  call，注意这里传入多少个参数是不确定的，所以使用apply是最好的，方法如下：</p>
<pre>
</pre>
<ol>
<li>function log(){ </li>
<li>    console.log.apply(console, arguments); </li>
<li>}; </li>
<li>log(1); //1 </li>
<li>log(1,2); //1 2  </li>
</ol>
<p>接下来的要求是给每一个 log 消息添加一个"(app)"的前辍，比如：</p>
<pre>
</pre>
<ol>
<li>log("hello world"); //(app)hello world </li>
</ol>
<p>该怎么做比较优雅呢?这个时候需要想到arguments参数是个伪数组，通过 Array.prototype.slice.call  转化为标准数组，再使用数组方法unshift，像这样：</p>
<pre>
</pre>
<ol>
<li>function log(){ </li>
<li>    var args = Array.prototype.slice.call(arguments); </li>
<li>    args.unshift('(app)'); </li>
<li> </li>
<li>    console.log.apply(console, args); </li>
<li>};  </li>
</ol>
<p><strong>bind</strong></p>
<p>说完了 apply 和 call ，再来说说bind。bind() 方法与 apply 和 call 很相似，也是可以改变函数体内 this  的指向。</p>
<p>MDN的解释是：bind()方法会创建一个新函数，称为绑定函数，当调用这个绑定函数时，绑定函数会以创建它时传入<br />
bind()方法的第一个参数作为  this，传入 bind()<br />
方法的第二个以及以后的参数加上绑定函数运行时本身的参数按照顺序作为原函数的参数来调用原函数。</p>
<p>直接来看看具体如何使用，在常见的单体模式中，通常我们会使用 _this , that , self 等保存 this  ，这样我们可以在改变了上下文之后继续引用到它。 像这样：</p>
<pre>
</pre>
<ol>
<li>var foo = { </li>
<li>bar : 1, </li>
<li>eventBind: function(){ </li>
<li>var _this = this; </li>
<li>$('.someClass').on('click',function(event) { </li>
<li>/* Act on the event */ </li>
<li>console.log(_this.bar); //1 </li>
<li>}); </li>
<li>} </li>
<li>}  </li>
</ol>
<p>由于 Javascript 特有的机制，上下文环境在 eventBind:function(){ } 过渡到<br />
$('.someClass').on('click',function(event) { }) 发生了改变，上述使用变量保存 this<br />
这些方式都是有用的，也没有什么问题。当然使用 bind() 可以更加优雅的解决这个问题：</p>
<pre>
</pre>
<ol>
<li>var foo = { </li>
<li>bar : 1, </li>
<li>eventBind: function(){ </li>
<li>$('.someClass').on('click',function(event) { </li>
<li>/* Act on the event */ </li>
<li>console.log(this.bar); //1 </li>
<li>}.bind(this)); </li>
<li>} </li>
<li>}  </li>
</ol>
<p>在上述代码里，bind() 创建了一个函数，当这个click事件绑定在被调用的时候，它的 this<br />
关键词会被设置成被传入的值(这里指调用bind()时传入的参数)。因此，这里我们传入想要的上下文 this(其实就是 foo )，到<br />
bind()  函数中。然后，当回调函数被执行的时候， this 便指向 foo 对象。再来一个简单的栗子：</p>
<pre>
</pre>
<ol>
<li>var bar = function(){ </li>
<li>console.log(this.x); </li>
<li>} </li>
<li> </li>
<li>bar(); // undefined </li>
<li>var func = bar.bind(foo); </li>
<li>func(); // 3  </li>
</ol>
<p>这里我们创建了一个新的函数 func，当使用 bind() 创建一个绑定函数之后，它被执行的时候，它的 this 会被设置成 foo ， 而不是像我们调用  bar() 时的全局作用域。</p>
<p>有个有趣的问题，如果连续 bind() 两次，亦或者是连续 bind() 三次那么输出的值是什么呢?像这样：</p>
<pre>
</pre>
<ol>
<li>var bar = function(){ </li>
<li>console.log(this.x); </li>
<li>} </li>
<li>var foo = { </li>
<li>x:3 </li>
<li>} </li>
<li>var sed = { </li>
<li>x:4 </li>
<li>} </li>
<li>var func = bar.bind(foo).bind(sed); </li>
<li>func(); //? </li>
<li> </li>
<li>var fiv = { </li>
<li>x:5 </li>
<li>} </li>
<li>var func = bar.bind(foo).bind(sed).bind(fiv); </li>
<li>func(); //?  </li>
</ol>
<p>答案是，两次都仍将输出 3 ，而非期待中的 4 和 5 。原因是，在Javascript中，多次 bind() 是无效的。更深层次的原因，<br />
 bind()  的实现，相当于使用函数在内部包了一个 call / apply ，第二次 bind() 相当于再包住第一次 bind()<br />
,故第二次以后的 bind  是无法生效的。</p>
<p><strong>apply、call、bind比较</strong></p>
<p>那么 apply、call、bind 三者相比较，之间又有什么异同呢?何时使用 apply、call，何时使用 bind 呢。简单的一个栗子：</p>
<pre>
</pre>
<ol>
<li>var obj = { </li>
<li>x: 81, </li>
<li>}; </li>
<li> </li>
<li>var foo = { </li>
<li>getX: function() { </li>
<li>return this.x; </li>
<li>} </li>
<li>} </li>
<li> </li>
<li>console.log(foo.getX.bind(obj)()); //81 </li>
<li>console.log(foo.getX.call(obj)); //81 </li>
<li>console.log(foo.getX.apply(obj)); //81  </li>
</ol>
<p>三个输出的都是81，但是注意看使用 bind() 方法的，他后面多了对括号。</p>
<p>也就是说，区别是，当你希望改变上下文环境之后并非立即执行，而是回调执行的时候，使用 bind() 方法。而 apply/call  则会立即执行函数。</p>
<p>再总结一下：</p>
<ul>
<li>apply 、 call 、bind 三者都是用来改变函数的this对象的指向的;</li>
<li>apply 、 call 、bind 三者第一个参数都是this要指向的对象，也就是想指定的上下文;</li>
<li>apply 、 call 、bind 三者都可以利用后续参数传参;</li>
<li>bind是返回对应函数，便于稍后调用;apply、call则是立即调用 。</li>
</ul>
<p>本文实例出现的所有代码，在我的github上可以下载。</p>
<p>本文作者：佚名</p>
<p>来源：51CTO</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-04 20:59:00</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/apple/" title="apple">apple</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e7%bb%84/" title="数组">数组</a>, <a href="https://www.iamivan.net/tag/javascript/" title="javascript">javascript</a>, <a href="https://www.iamivan.net/tag/prototype/" title="prototype">prototype</a>, <a href="https://www.iamivan.net/tag/log/" title="LOG">LOG</a>, <a href="https://www.iamivan.net/tag/bind/" title="BIND">BIND</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>深入浅出妙用Javascript中apply、call、bind的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlOAL8b.html" rel="bookmark">【优雅代码】深入浅出 妙用Javascript中apply、call、bind</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这篇文章实在是很难下笔,因为网上相关文章不胜枚举. 巧合的是前些天看到阮老师的一篇文章的一句话: &quot;对我来说,博客首先是一种知识管理工具,其次才是传播工具.我的技术文章,主要用来整理我还不懂的知识.我只写那些我还没有完全掌握的东西,那些我精通的东西,往往没有动力写.炫耀从来不是我的动机,好奇才是.&quot; 对于这句话,不能赞同更多,也让我下决心好好写这篇,网上文章虽多,大多复制粘贴,且晦涩难懂,我希望能够通过这篇文章,能够清晰的提升对apply.call.bind的认识,并且列出一些它们的妙			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z443r9z.html" rel="bookmark">开启Javascript中apply、call、bind的用法之旅模式&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我希望能够通过这篇文章,能够清晰的提升对apply.call.bind的认识,并且列出一些它们的妙用加深记忆. apply.call 在 javascript 中,call 和 apply 都是为了改变某个函数运行时的上下文(context)而存在的,换句话说,就是为了改变函数体内部 this 的指向. JavaScript 的一大特点是,函数存在「定义时上下文」和「运行时上下文」以及「上下文是可以改变的」这样的概念. 先给大家列出一段代码示例: function fruits() {} fru			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MW770XM.html" rel="bookmark">javascript中apply、call和bind的使用区别&lowbar;基础知识</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在JS中,这三者都是用来改变函数的this对象的指向的,他们有什么样的区别呢. 在说区别之前还是先总结一下三者的相似之处: 1.都是用来改变函数的this对象的指向的. 2.第一个参数都是this要指向的对象. 3.都可以利用后续参数传参. 那么他们的区别在哪里的,先看一个例子. var xw = { name : &quot;小王&quot;, gender : &quot;男&quot;, age : 24, say : function() { alert(this.name + &quot; ,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze0dkVp.html" rel="bookmark">Javascript中apply、call、bind的巧妙使用&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				apply.call 在 javascript 中,call 和 apply 都是为了改变某个函数运行时的上下文(context)而存在的,换句话说,就是为了改变函数体内部 this 的指向. JavaScript 的一大特点是,函数存在「定义时上下文」和「运行时上下文」以及「上下文是可以改变的」这样的概念. 先来一个栗子: function fruits() {} fruits.prototype = { color: &quot;red&quot;, say: function() { console			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8ZWL3b.html" rel="bookmark">JavaScript中apply方法的应用技巧小结&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 最近在看JavaScript设计模式,其中有一些巧妙的函数.所以将部分修改后记录在此,顺便加上自己写出的一些好玩的函数.方便大家和自己以后使用.下面来一起看看. 一.apply实现call Function.prototype.call = function () { var ctx = [].shift.apply(arguments) return this.apply(ctx, arguments) } 二.apply实现bind Function.prototype.bind =			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1N9Exp.html" rel="bookmark">深入理解关于javascript中apply&lpar;&rpar;和call&lpar;&rpar;方法的区别&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如果没接触过动态语言,以编译型语言的思维方式去理解javaScript将会有种神奇而怪异的感觉,因为意识上往往不可能的事偏偏就发生了,甚至觉得不可理喻.如果在学JavaScript这自由而变幻无穷的语言过程中遇到这种感觉,那么就从现在形始,请放下的您的&quot;偏见&quot;,因为这对您来说绝对是一片新大陆,让JavaScrip慢慢融化以前一套凝固的编程意识,注入新的生机! 好,言归正传,先理解JavaScrtipt动态变换运行时上下文特性,这种特性主要就体现在apply, call两个方法的运用上.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvE508b.html" rel="bookmark">Javascript中apply、call、bind</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				网上文章虽多,大多复制粘贴,且晦涩难懂,我希望能够通过这篇文章,能够清晰的提升对apply.call.bind的认识,并且列出一些它们的妙用加深记忆. apply.call  在 javascript 中,call 和 apply 都是为了改变某个函数运行时的上下文(context)而存在的,换句话说,就是为了改变函数体内部 this 的指向. JavaScript 的一大特点是,函数存在「定义时上下文」和「运行时上下文」以及「上下文是可以改变的」这样的概念. 先来一个栗子: 1 2 3 4 5			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4wEdPp.html" rel="bookmark">在JavaScript中正确引用bind方法的应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  本文的重点在于讨论bind()方法的实现,在开始讨论bind()的实现之前,我们先来看看bind()方法的使用,有需要的小伙伴可以参考下. 在JavaScript中,方法往往涉及到上下文,也就是this,因此往往不能直接引用,就拿最常见的console.log(&quot;info-&quot;)来说,避免书写冗长的console,直接用log(&quot;info-&quot;)代替,不假思索的会想到如下语法: ? 1 2 var log = console.log; log(&quot;info-			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mg3mr6M.html" rel="bookmark">JavaScript中的prototype&period;bind&lpar;&rpar;方法介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 在JavaScript中,我们经常用到函数绑定,而当你需要在另一个函数中保持this上下文时,使用Function.prototype.bind()会很方便 以前,你可能会直接设置self=this或者that=this等等,这样做当然也能起作用,但是使用Function.prototype.bind()会更好,看上去也更专业. 下面举个简单的例子:   代码如下: var myObj = {     specialFunction: function () {     },     anot			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvYvrb.html" rel="bookmark" class="title">cpp-如何读取很多个xml文件，并且发布其中标记的数据</a>
					<div>
						问题描述 如何读取很多个xml文件,并且发布其中标记的数据 情况是这样的,老大教我做一个功能.1,发布数据,发布自己标记后的数据.2,xml的大量数据,对有需要的数据进行标记.我现在已经完成了2,完成 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMq5oKM.html" rel="bookmark" class="title">asp记录日志程序</a>
					<div>
						程序 '书写日志的程序?'username :用户信息(标示进行该操作的人员)'operate :操作(标示用户进行了什么操作)'userip :用户IP(标示用户用于登录系统的计算机的IP地址)'o ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOPXvb.html" rel="bookmark" class="title">为什么SEO博客里文章的质量越来越低了</a>
					<div>
						最近和一次朋友聊天,那位朋友抱怨现在想学点东西不容易了,以前发现博客是最能学习到东西的.但现在博客里的东西怎么越来越水了,相信可能做了一年以上SEO的人都会有这样的感觉,为何会出现博客内容质量越来越低 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM1Vrop.html" rel="bookmark" class="title">SEOmoz发布2011年Google排名因素调查报告</a>
					<div>
						SEOmoz近日发布了2011版Google排名因素调查报告.此次SEOmoz通过132名顶级的搜索引擎优化专家对1000多条搜索结果进行投票调查并总结出最新的排名因素变化.但是这些整合的数据只能作为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4419p.html" rel="bookmark" class="title">ASP&period;NET MVC基于标注特性的Model验证：DataAnnotationsModelValidator</a>
					<div>
						对于ASP.NET MVC基于标注特性的Model验证,很多人只知道应用在数据类型及其属性上用于定义验证规则和错误消息的ValidationAttribute.通过&lt;ASP.NET MVC以Mo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk28Z5M.html" rel="bookmark" class="title">css 文本两端对齐应用实例</a>
					<div>
						在做表单时我们经常遇到让上下两个字段对齐的情况,比如姓名, 手机号码, 出生地.这样我们就要用到 text-align, text-justify样式了. text-align直接设为justify就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj70P6M.html" rel="bookmark" class="title">怎样去掉word文档页眉下的横线</a>
					<div>
						Word 2007为大家制作文档的页眉和页脚提供了非常便利的方法,我们只需要轻松单击选择一下,专业的页眉和页脚就跃然纸上了.但是,在插入到文档的页眉下面会出现一条横线,这个线条可以去掉或修改线条的样式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVnKPKz.html" rel="bookmark" class="title">&amp;quot&semi;本地连接&amp;quot&semi;有发送无接收数据的解决方法</a>
					<div>
						1.禁用网卡,然后重新启用,重新启动电脑.插拔网线,看情况是否改善.(备注:用这个办法我也解决了好多这类问题,简单不费时间.) 2.卸载网卡驱动,重新安装网卡驱动,然后分配IP地址.(备注:我曾经给别 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlR5xDz.html" rel="bookmark" class="title">按日期打印Python的Tornado框架中的日志的方法</a>
					<div>
						  这篇文章主要介绍了按日期打印Python的Tornado框架中的日志的方法,需要的朋友可以参考下 网站流量上来后,日志按天甚至小时存储更方便查看和管理,而Python的logging模块也提供了T ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN10LNb.html" rel="bookmark" class="title">Windows8系统下调整颜色质量</a>
					<div>
						  1.桌面空白处右击,选择&quot;屏幕分辨率&quot;; 2.选择&quot;高级设置&quot;; 3.选择&quot;监视器&quot;. 注:发现在Windows 8 Consumer  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGo7Np.html" rel="bookmark" class="title">支付宝碎屏险有什么用？</a>
					<div>
						  碎屏险是什么? 碎屏险是支付宝新推出的一项服务,通俗的说,就是为您的手机屏幕买保险,当手机由于意外摔落,导致屏幕损坏后,支付宝将会为您全额赔偿,会您免费更换全新屏幕. 支付宝碎屏险须知 1.支付宝 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42DYqM.html" rel="bookmark" class="title">无法访问网上邻居</a>
					<div>
						  在平时使用其他电脑上资源的时候,选择&quot;网上邻居&quot;后,有时会出现一个&quot;无法访问网上邻居,网络不能访问&quot;的提示,有时候则能看到自己,不能看到别人.有时则&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badVAgz.html" rel="bookmark" class="title">阿里云发布NAS Plus：支持12层4K级非编</a>
					<div>
						5月23日,阿里云正式推出了云上首个支持广电级非编的文件存储产品--NAS Plus.作为阿里云文件存储的升级版,NAS Plus提供高达200Gbps的吞吐性能和低至1毫秒的超低延迟,支持12层4K ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32mOAz.html" rel="bookmark" class="title">android-关于Android IDevicePolicyManager&period;aidl的问题</a>
					<div>
						问题描述 关于Android IDevicePolicyManager.aidl的问题 看关于Android锁屏的代码看到最后是调用了IDevicePolicyManager.aidl里面的方法.比如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWQ5mp.html" rel="bookmark" class="title">系数-加速度数据的卡尔曼滤波问题</a>
					<div>
						问题描述 加速度数据的卡尔曼滤波问题 目前我在ADXL345加速度传感器获取加速度数据(已经得到),现在要用卡尔曼滤波方法进行实时软件滤波处理,可是卡尔曼滤波里的过程噪声W和观测噪声V是怎么确定的?这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxoeyPb.html" rel="bookmark" class="title">Linux Shell脚本之Atlassian confluence远程备份方法</a>
					<div>
						原创作品,允许转载,转载时请务必以超链接形式标明文章 原始出处 .作者信息和本声明.否则将追究法律责任.http://dgd2010.blog.51cto.com/1539422/1686013 注: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPqvlp.html" rel="bookmark" class="title">穿越时空 一台家庭NAS能为你带来什么</a>
					<div>
						 如果要定义一台家庭NAS能为所有者带来什么,我们首先要明确一点:你不能太懒.这就像是一个摄影爱好者,觉得自己需要买一台相机,而在相机购买成功后的一个月后,相机/单反被束之高阁,而如果你很懒,一台家庭 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN74rop.html" rel="bookmark" class="title">构建安全应用程序架构必须考虑的十二问</a>
					<div>
						应用程序的架构检查是指检查应用程序架构中当前的安全控制.这种检查有助于用户在早期确认潜在的安全漏洞,并在开始开发之前就极大地减少漏洞.糟糕的架构设计有可能暴露出应用程序的许多安全漏洞.最好的办法是在设 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvr1kVM.html" rel="bookmark" class="title">【整理】mongodb 3&period;2 新版本特性</a>
					<div>
						mongodb 3.2 新版本特性  内存数据库(beta)  更加高的并发处理能力 更加短的响应时间 适用于:广告.金融.通信等行业: 2016 GA :  网传:mongodb 就是内存数据库?! ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2POPkp.html" rel="bookmark" class="title">MapReduce核心map reduce shuffle （spill sort partition merge）详解</a>
					<div>
						  Shuffle过程是MapReduce的核心,也被称为奇迹发生的地方.要想理解MapReduce, Shuffle是必须要了解的.Shuffle的正常意思是洗牌或弄乱,可能大家更熟悉的是Java  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY57l5M.html" rel="bookmark" class="title">Qt之对象树与所有权</a>
					<div>
						简述 QObjects在一个对象树中组织他们自己.当创建一个QObject时,如果使用了其他对象作为其父对象,那么,它就会被添加到父对象的children()列表中.这样一来,当父对象被销毁时,这个Q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myd6jdb.html" rel="bookmark" class="title">&lbrack;j2me&rsqb;利用kSOAP让MIDP设备与WebService之间传递类对象&lbrack;上&rsqb;</a>
					<div>
						 测试代码下载:http://files.cnblogs.com/zhengyun_ustc/WSCallerMIDlet.rar [j2me]利用kSOAP让MIDP设备与 WebService之间 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRa76b.html" rel="bookmark" class="title">javaweb 报classnotfoundexception</a>
					<div>
						问题描述 javaweb 报classnotfoundexception public void SetDic(String dicFile) { ObjectInputStream objectIn ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7rROz.html" rel="bookmark" class="title">UEP企业成长计划：新时代创业者光环</a>
					<div>
						  2015年,国家制定出台了一系列推进&quot;大众创业.万众创新&quot;的政策措施,从产业经济层面给创业者巨大的帮助.引发大量的年轻人投身到创业浪潮中,仅仅在过去两年,我国便诞生了数十万个互 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoN8OM.html" rel="bookmark" class="title">百融金服受资本热捧 开启金融大数据2&period;0时代</a>
					<div>
						ZD至顶网软件频道消息:提前到来的资本寒冬让投资者们捂紧了自己的钱包,以更加审慎的态度考量互联网市场.有人说,这一时期每一笔&quot;来之不易&quot;的投资都是行业风向的一个信号,而这一次,位于 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQAqVp.html" rel="bookmark" class="title">listview分组加载怎么自动对程序进行分类呢？</a>
					<div>
						问题描述 listview分组加载怎么自动对程序进行分类呢? 根据图标的种类对图标方式进行分类,listview分组加载怎么自动对程序进行分类呢? 解决方案 可以通过程序版本信息对程序分类,用getv ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEKPdZp.html" rel="bookmark" class="title">C&num;程序 使用vs 使用&OpenCurlyDoubleQuote;调试&rdquo;能实现功能，但是使用 &OpenCurlyDoubleQuote;开始执行（不调试）&rdquo;就不能实现功能</a>
					<div>
						问题描述 如题,程序实现的一个功能,调试情况下都没问题,但是直接执行(ctrl+F5)就不会实现该功能,求大神们来帮帮忙,弄了一天没搞定,或者给点什么思路如何解决这个问题 解决方案 解决方案二:你确定 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGr9rep.html" rel="bookmark" class="title">聊天软件都去抄Snapchat Stories，为啥会这样</a>
					<div>
						在过去1年间,全世界的社交应用都在抄同一个东西,Snapchat的Stories. 今年4月份开始,微博找了部分用户测试&quot;故事&quot;功能.Facebook家的Instagram.Fac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOnLvvp.html" rel="bookmark" class="title">求救！！java中怎么让一串字符串自增</a>
					<div>
						问题描述 RT:其中这个字符串有可能包含字母,字母也需要自增... 解决方案 解决方案二:lz,能不能说清楚点解决方案三:可以把字符串转成字符数组.再一个个加减,再转成字符串Stringss=&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWdDjGp.html" rel="bookmark" class="title">c语言题目求指导~~初学数组 谢谢</a>
					<div>
						问题描述 c语言题目求指导~~初学数组 谢谢 #include int main() { int a[9]={1,2,3,4,6,9,12,23,45},b[10],i,j,n; scanf(&quo ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
